/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <mpu92xx.h>
#include <project.h>
#include "FS.h"
#include <FS.h> 
#include "cyapicallbacks.h"

#define DMA_TX_BYTES_PER_BURST      (1u)
#define DMA_TX_REQUEST_PER_BURST    (1u)
#define DMA_TX_SRC_BASE             (CYDEV_SRAM_BASE)
#define DMA_TX_DST_BASE             (CYDEV_PERIPH_BASE)

/* DMA Configuration for DMA_RX */
#define DMA_RX_BYTES_PER_BURST      (1u)
#define DMA_RX_REQUEST_PER_BURST    (1u)
#define DMA_RX_SRC_BASE             (CYDEV_PERIPH_BASE)
#define DMA_RX_DST_BASE             (CYDEV_SRAM_BASE)

#define BUFFER_SIZE                 (2u)
#define STORE_TD_CFG_ONCMPLT        (1u)

uint8 accSaveActive=0,accTimeActive=0;

volatile uint8_t Interrupt_Status;
uint8 InterruptControl;

uint8 gyroSaveActive=0;
uint8 start=0;
char gyro[12]= "gyrData.txt";
char acc[12]= "accData.txt";
uint8 stateForGyro=0, stateForAcc=0;

FS_FILE * pFile;
FS_FILE * p2File;

int16 accArray[BUFFER_SIZE];
uint16 time;

uint8 txChannel;
uint8 txTD[4];
uint8 i=0, a=0;
uint16 k=0,c;
char m[10];
/* Variable declarations for DMA_RX */
uint8 rxChannel;
uint8 rxTD[2];

uint8 TD_InterruptControl;
uint8 txBuffer [BUFFER_SIZE] = {MPUREG_WHOAMI|0x80, 0x00u};
int8 rxBuffer[BUFFER_SIZE];

	
void printconsole(int16_t value);
void DmaTxConfiguration(void);
void DmaRxConfiguration(void);
void DmaGyroRxConfiguration(void);
void DmaGyroTxConfiguration(void);
void DMA_clearInterrupt_Config(void);

/* Data buffers */
int16 sdBuffer[4096];
int16 sdBufferAcc[4096];
uint8 controlregSelect=0;
uint8 controlregDeselect=1;

int8 response[6];
int16_t bit_data;
float data;


CY_ISR(isr_acceleration){
	FS_Write(p2File, (uint8*)rxBuffer, (BUFFER_SIZE*2)); 
	//accSaveActive=1;

}
CY_ISR(timerISR){
	//SPIM_TX_STATUS_MASK_REG|=(SPIM_INT_ON_TX_EMPTY);
	accTimeActive=1;
	
}

int main(){	
	
	SPIM_Start();
	UART_Start();
	Timer_1_Start();
	
	//SPIM_TX_STATUS_MASK_REG&=(~SPIM_INT_ON_TX_EMPTY);
	//SPIM_TX_STATUS_MASK_REG|=(SPIM_INT_ON_TX_EMPTY);
    //InterruptControl=SPIM_TX_STATUS_MASK_REG;
	
    UART_PutString(" Connected to Computer\n\r");
    CyGlobalIntEnable; /* Enable global interrupts. */
	
	init(1,500);
	CyDelay(1);
	i = whoami();
	printconsole(i);
	calib_acc();
	set_gyro_scale(BITS_FS_2000DPS);
	i=set_acc_scale(BITS_FS_2G);
	printconsole(i);
	UART_PutString("\n\r");
	CyDelay(1);
	
	isr_acc_StartEx(isr_acceleration);
	//timerInterrupt_StartEx(timerISR);
	
	FS_Init();
	pFile = FS_FOpen(gyro, "w");
    p2File = FS_FOpen(acc, "w");
	
	DmaTxConfiguration();
    DmaRxConfiguration();
	
	CyDmaChEnable(rxChannel, 1);
    CyDmaChEnable(txChannel, 1);
	
	Led_Write(1);

	
	for(;;){
		if(accTimeActive==1){
			SPIM_ClearTxBuffer();    
           	accSaveActive=0;
			accTimeActive=0;
           	CyDmaChStatus(txChannel,&a,0); 
			FS_Write(p2File, (uint8*)rxBuffer, (BUFFER_SIZE*2)); 
           	
			for(i=0; i<3; i++) {
     			bit_data=((int16_t)rxBuffer[i*2+1]<<8)|rxBuffer[i*2+2];
        		data=(float)bit_data;
        		accelerometer_data[i]=(data/acc_divider)*100;
    		}
			i=0;
			
			if (stateForAcc){
	            //FS_Write(pFile, (uint8*)rxGyroBuffer, (BUFFER_SIZE*2));
	            stateForAcc= 0; 
	            a=0;
	        }
	        else{
	            FS_Write(p2File, (uint8*)rxBuffer, (BUFFER_SIZE*2)); 
				stateForAcc= 1;
	            a=2;
			}
		}
    }
}
void printconsole(int16_t value){
    char writtenString[15];
    sprintf(writtenString,"%d", value);
    UART_PutString(writtenString);
	
   // UART_UartPutString(" "); //print backspace character
}

void DmaTxConfiguration()
{
    /* Init DMA, 1 byte bursts, each burst requires a request */ 
        txChannel = DMA_TX_DmaInitialize(DMA_TX_BYTES_PER_BURST, DMA_TX_REQUEST_PER_BURST, 
                                        HI16(txBuffer), HI16(SPIM_TXDATA_PTR));

    txTD[0] = CyDmaTdAllocate();
	TD_InterruptControl = CyDmaTdAllocate();

    CyDmaTdSetConfiguration(txTD[0], BUFFER_SIZE, txTD[0],TD_INC_SRC_ADR);
	//CyDmaTdSetConfiguration(TD_InterruptControl, 1, txTD[0], 	0);


    CyDmaTdSetAddress(txTD[0], (uint16)((uint32)txBuffer), (uint16)((uint32) SPIM_TXDATA_PTR));
	//CyDmaTdSetAddress(TD_InterruptControl, (uint16)((uint32)&InterruptControl),(uint16)((uint32)&SPIM_TX_STATUS_MASK_REG));

    CyDmaChSetRequest(txChannel, CPU_TERM_CHAIN);
	CyDmaChEnable(txChannel, 1);
    CyDmaChSetInitialTd(txChannel, txTD[0]); 
	CyDmaChEnable(txChannel, 1);
}    


/*******************************************************************************
* Function Name: DmaRxConfiguration
********************************************************************************
* Summary:
*  Configures the DMA transfer for RX direction
*   
* Parameters:
*  None.
*
* Return:
*  None.
*
*******************************************************************************/
void DmaRxConfiguration()
{ 

	uint8 DMA_ClearSPITxInterrupt_Chan;
	uint8 DMA_ClearSPITxInterrupt_TD[1];

	rxChannel = DMA_RX_DmaInitialize(DMA_RX_BYTES_PER_BURST, DMA_RX_REQUEST_PER_BURST,
                                     HI16(SPIM_RXDATA_PTR), HI16(&rxBuffer[0]));

    rxTD[0] = CyDmaTdAllocate();
    
    /* Configure this Td as follows:
    *  - Increment the destination address, but not the source address
    */
    CyDmaTdSetConfiguration(rxTD[0], BUFFER_SIZE, rxTD[0], TD_INC_DST_ADR| DMA_RX__TD_TERMOUT_EN);

    /* From the SPIM to the memory */
    CyDmaTdSetAddress(rxTD[0], LO16((uint32)SPIM_RXDATA_PTR), LO16((uint32)&rxBuffer[0]));

    /* Associate the TD with the channel */
    CyDmaChSetInitialTd(rxChannel, rxTD[0]);
}
